package jumbo.xml;

/** a class for Exceptions thrown within jumbo.xml routines. Like
jumbo.sgml.JumboException this will develop to try to display the
messages as meaningfully as possible. Still rudimentary.
@author P.Murray-Rust, 1998
*/
public class XException extends Exception {
	Exception exception;
	String message;
/** no message provided */
	public XException() {
		super();
	}
/** store the message */
	public XException(String s) {
		super(s);
		message = s;
	}
/** store the original exception for later display */
	public XException(Exception e) {
		this.exception = e;
	}
/** store the original exception and message for later display */
	public XException(Exception e, String s) {
		this(s);
		this.exception = e;
	}

	public String toString() {
		String s = "<!--Ex: ";
		if (this.exception != null) {
			s += "X:"+exception.toString()+"\n";
			StackTraceWriter stw = new StackTraceWriter();
			exception.printStackTrace(stw);
			s += stw.toString()+"\n";
		}
		s += message+":Ex-->";
		return s;
	}
}