package jumbo.xml;

// hacked from swing-1.0.1 examples

import com.sun.java.swing.Icon;
import com.sun.java.swing.ImageIcon;
import com.sun.java.swing.JButton;
import com.sun.java.swing.JLabel;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JTree;
import com.sun.java.swing.SwingConstants;

import com.sun.java.swing.tree.TreeCellRenderer;
import com.sun.java.swing.tree.DefaultMutableTreeNode;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
/** derived from SwingSet examples to allow customisation of the
node display in the trees. Used to work nicely but has stopped.	I will
comment this more when it works - at present the comments are 
primarily from the SwingSet docs.
*** There is a bug of some sort here and JLabel.setIcon() seems to give
problems whereby the icon is not properly rendered.	Therefore some of this
code represents experiements
@author P.Murray-Rust, 1998
*/
public class XTreeCellRenderer extends /*JPanel*/ JLabel implements TreeCellRenderer {
    static protected Font             defaultFont;
//    static protected ImageIcon        collapsedIcon;
//    static protected ImageIcon        expandedIcon;
//    static protected ImageIcon        jumbo;
    static protected ImageIcon        blueBall;


    static protected final Color selectedBackgroundColor = Color.yellow;//new Color(0, 0, 128);

    static {
	  try {
	      defaultFont = new Font("Helvetica", Font.PLAIN, 12);
	  } catch (Exception e) {}
	  try {
//	      collapsedIcon = new ImageIcon("images/collapsed.gif");
//	      expandedIcon = new ImageIcon("images/expanded.gif");
//		  blueBall = new ImageIcon("blue-ball.gif");
//		  jumbo = new ImageIcon("jumbo.gif");
	  } catch (Exception e) {
	      System.out.println("Couldn't load images: " + e);
	  }
    }

/** Whether or not the item that was last configured is selected. */
    protected boolean            selected;

/** kludge; jLabel can be set to 'this' when XTreeCellRenderer is
subclassed from JLable; else to jLable add'ed to JPanel
*/
	protected JLabel jLabel;
	protected JButton jButton;

	public XTreeCellRenderer() {
// won't work at present
		super("Default", blueBall, SwingConstants.LEFT); // for JLabel
		jLabel = this;									 // for JLabel
		if (!(this instanceof JLabel)) {
			this.setLayout(new BorderLayout());
			jLabel = new JLabel("XYZZY");
			this.add(jLabel, BorderLayout.CENTER);
			jButton = new JButton();
			jButton.setIcon(blueBall);
			this.add(jButton, BorderLayout.WEST);
		}
	}

    /**
      * This is messaged from JTree whenever it needs to get the size
      * of the component or it wants to draw it.
      * This attempts to set the font based on value, which will be
      * a TreeNode.
      */
    public Component getTreeCellRendererComponent(JTree tree, Object value,
					  boolean selected, boolean expanded,
					  boolean leaf, int row,
						  boolean hasFocus) {
		Font            font;
		String          stringValue = tree.convertValueToText(value, selected,
					   expanded, leaf, row, hasFocus);
		if (stringValue != null) {
			jLabel.setText(stringValue);
			setToolTipText(stringValue);
		} else {
			jLabel.setText("Default");
			setToolTipText("Default");
		}

/*--
		if(expanded) {
			jLabel.setIcon(expandedIcon);
		} else if(!leaf){
			jLabel.setIcon(collapsedIcon);
		}
--*/

//	Object         userObject = ((XNode)value)
//	                                .getUserObject();
		Color foregroundColor = Color.red;
		Color objectColor = Color.pink;
		XNode userObject = null;
		if (value instanceof String) {
			objectColor = Color.blue;
		} else {
			userObject = (XNode) value;
			objectColor = userObject.getColor();
//			Icon elementIcon = userObject.getIcon();
//			if (elementIcon != null) {
//				setIcon(elementIcon);
//			}
		}
		if(hasFocus) {
		    jLabel.setForeground(foregroundColor);
		} else {
		    jLabel.setForeground(objectColor);
		}
		if (userObject == null) {
		    jLabel.setFont(XNode.getDefaultFont());
		} else {
		    jLabel.setFont(userObject.getFont());
		}
	/* Update the selected flag for the next paint. */
		this.selected = selected;
	
		return this;
    }

    /**
      * paint is subclassed to draw the background correctly.  JLabel
      * currently does not allow backgrounds other than white, and it
      * will also fill behind the icon.  Something that isn't desirable.
      */
	public void paint(Graphics g) {
		paintLabel(g);
	}
    public void paintLabel(Graphics g) {
		this.setVisible(true);
	    Color bColor;
	    Icon  currentIcon = jLabel.getIcon();

  	    if (selected) {
	        bColor = selectedBackgroundColor;
	    } else if(getParent() != null) {
/* Pick background color up from parent (which will come from
the JTree we're contained in). */
	        bColor = getParent().getBackground();
	    } else {
	        bColor = getBackground();
  	    }
	    g.setColor(bColor);
	    if (currentIcon != null && jLabel.getText() != null) {
		    int offset = (currentIcon.getIconWidth() + jLabel.getIconTextGap());
		    g.fillRect(offset, 0, jLabel.getWidth() - 1 - offset, jLabel.getHeight() - 1);
	    } else {
		    g.fillRect(0, 0, jLabel.getWidth()-1, jLabel.getHeight()-1);
		    super.paint(g);
	    }
    }
	public int getWidth() {
		return 100;
	}
	public int getHeight() {
		return 20;
	}
}